unit StructVerDEFVER_UNISUF_;

interface
uses
  MyTypes, Int64Em, structDEFVER_UNISUF_;

{$DEFINE ARCH_UNISUF_}
// If unit for non-unicode version then previous define will be just ARCH
// so UNICODE will not be defined 
{$IFDEF ARCHu}
  {$DEFINE UNICODE}
{$ENDIF}

const UNI_FIRST = 5205;  

type
  TAnInnoVer = class(TInnoVer)
  public
    constructor Create; override;
    procedure SetupSizes; override;
    procedure UnifySetupLdrOffsetTable(const p; var ot:TMySetupLdrOffsetTable); override;
    procedure UnifySetupHeader(const p; var sh:TMySetupHeader); override;
    procedure UnifyFileEntry(const p; var fe:TMySetupFileEntry); override;
    procedure UnifyFileLocationEntry(const p; var fl:TMySetupFileLocationEntry); override;
    procedure UnifyRegistryEntry(const p; var re:TMySetupRegistryEntry); override;
    procedure UnifyRunEntry(const p; var re:TMySetupRunEntry); override;
    procedure UnifyIconEntry(const p; var ie:TMySetupIconEntry); override;
    procedure UnifyTaskEntry(const p; var te:TMySetupTaskEntry); override;
    procedure UnifyComponentEntry(const p; var ce:TMySetupComponentEntry); override;
    procedure UnifyTypeEntry(const p; var te:TMySetupTypeEntry); override;
    procedure UnifyCustomMessageEntry(const p; var ce:TMySetupCustomMessageEntry); override;
    procedure UnifyLanguageEntry(const p; var le:TMySetupLanguageEntry); override;
    procedure UnifyDirEntry(const p; var de: TMySetupDirEntry); override;
    procedure UnifyIniEntry(const p; var ie: TMySetupIniEntry); override;
    procedure UnifyDeleteEntry(const p; var de: TMySetupDeleteEntry); override;
  end;

implementation

const
  SetupFileOptionTable: array [0..MySetupFileOptionLast] of byte = (
  ord(structDEFVER_UNISUF_.foConfirmOverwrite)                                           ,  {foConfirmOverwrite        }
  ord(structDEFVER_UNISUF_.foUninsNeverUninstall)                                        ,  {foUninsNeverUninstall     }
  ord(structDEFVER_UNISUF_.foRestartReplace)                                             ,  {foRestartReplace          }
  ord(structDEFVER_UNISUF_.foDeleteAfterInstall)                                         ,  {foDeleteAfterInstall      }
  ord(structDEFVER_UNISUF_.foRegisterServer)                                             ,  {foRegisterServer          }
  ord(structDEFVER_UNISUF_.foRegisterTypeLib)                                            ,  {foRegisterTypeLib         }
  ord(structDEFVER_UNISUF_.foSharedFile)                                                 ,  {foSharedFile              }
  {$IF DEFVER>=3005}
  ord(structDEFVER_UNISUF_.foCompareTimeStamp)                                           ,  {foCompareTimeStamp        }
  {$ELSE}
  ord(structDEFVER_UNISUF_.foCompareTimeStampAlso)                                       ,  {foCompareTimeStamp        }
  {$IFEND}
  ord(structDEFVER_UNISUF_.foFontIsntTrueType)                                           ,  {foFontIsntTrueType        }
  ord(structDEFVER_UNISUF_.foSkipIfSourceDoesntExist)                                    ,  {foSkipIfSourceDoesntExist }
  ord(structDEFVER_UNISUF_.foOverwriteReadOnly)                                          ,  {foOverwriteReadOnly       }
  ord(structDEFVER_UNISUF_.foOverwriteSameVersion)                                       ,  {foOverwriteSameVersion    }
  ord(structDEFVER_UNISUF_.foCustomDestName)                                             ,  {foCustomDestName          }
  ord(structDEFVER_UNISUF_.foOnlyIfDestFileExists)                                       ,  {foOnlyIfDestFileExists    }
  ord(structDEFVER_UNISUF_.foNoRegError)                                                 ,  {foNoRegError              }
  {$IF DEFVER>=3001}ord(structDEFVER_UNISUF_.foUninsRestartDelete)    {$ELSE}255{$IFEND} ,  {foUninsRestartDelete      }
  {$IF DEFVER>=3005}ord(structDEFVER_UNISUF_.foOnlyIfDoesntExist)     {$ELSE}255{$IFEND} ,  {foOnlyIfDoesntExist       }
  {$IF DEFVER>=3005}ord(structDEFVER_UNISUF_.foIgnoreVersion)         {$ELSE}255{$IFEND} ,  {foIgnoreVersion           }
  {$IF DEFVER>=3005}ord(structDEFVER_UNISUF_.foPromptIfOlder)         {$ELSE}255{$IFEND} ,  {foPromptIfOlder           }
  {$IF DEFVER>=4000}ord(structDEFVER_UNISUF_.foDontCopy)              {$ELSE}255{$IFEND} ,  {foDontCopy                }
  {$IF DEFVER>=4005}ord(structDEFVER_UNISUF_.foUninsRemoveReadOnly)   {$ELSE}255{$IFEND} ,  {foUninsRemoveReadOnly     }
  {$IF DEFVER>=4108}ord(structDEFVER_UNISUF_.foRecurseSubDirsExternal){$ELSE}255{$IFEND} ,  {foRecurseSubDirsExternal  }
  {$IF DEFVER>=5102}ord(structDEFVER_UNISUF_.fo32bit)                 {$ELSE}255{$IFEND} ,  {fo32bit                   }
  {$IF DEFVER>=5102}ord(structDEFVER_UNISUF_.fo64bit)                 {$ELSE}255{$IFEND} ,  {fo64bit                   }
  {$IF DEFVER>=5200}ord(structDEFVER_UNISUF_.foExternalSizePreset)    {$ELSE}255{$IFEND} ,  {foExternalSizePreset      }
  {$IF DEFVER>=5200}ord(structDEFVER_UNISUF_.foSetNTFSCompression)    {$ELSE}255{$IFEND} ,  {foSetNTFSCompression      }
  {$IF DEFVER>=5200}ord(structDEFVER_UNISUF_.foUnsetNTFSCompression)  {$ELSE}255{$IFEND} ,  {foUnsetNTFSCompression    }
  {$IF DEFVER>=5300}ord(structDEFVER_UNISUF_.foGacInstall)            {$ELSE}255{$IFEND}    {foGacInstall              }
);

  SetupRegistryOptionTable: array[0..MySetupRegistryOptionLast] of byte = (
  ord(structDEFVER_UNISUF_.roCreateValueIfDoesntExist)                                   ,  {roCreateValueIfDoesntExist    }
  ord(structDEFVER_UNISUF_.roUninsDeleteValue)                                           ,  {roUninsDeleteValue            }
  ord(structDEFVER_UNISUF_.roUninsClearValue)                                            ,  {roUninsClearValue             }
  ord(structDEFVER_UNISUF_.roUninsDeleteEntireKey)                                       ,  {roUninsDeleteEntireKey        }
  ord(structDEFVER_UNISUF_.roUninsDeleteEntireKeyIfEmpty)                                ,  {roUninsDeleteEntireKeyIfEmpty }
  ord(structDEFVER_UNISUF_.roPreserveStringType)                                         ,  {roPreserveStringType          }
  ord(structDEFVER_UNISUF_.roDeleteKey)                                                  ,  {roDeleteKey                   }
  ord(structDEFVER_UNISUF_.roDeleteValue)                                                ,  {roDeleteValue                 }
  ord(structDEFVER_UNISUF_.roNoError)                                                    ,  {roNoError                     }
  ord(structDEFVER_UNISUF_.roDontCreateKey)                                              ,  {roDontCreateKey               }
  {$IF DEFVER>=5100}ord(structDEFVER_UNISUF_.ro32bit)                 {$ELSE}255{$IFEND} ,  {ro32bit                       }
  {$IF DEFVER>=5100}ord(structDEFVER_UNISUF_.ro64bit)                 {$ELSE}255{$IFEND}    {ro64bit                       }
);

  SetupDirOptionTable: array[0..MySetupDirOptionLast] of byte = (
  ord(structDEFVER_UNISUF_.doUninsNeverUninstall)                                          ,  {doUninsNeverUninstall   }
  ord(structDEFVER_UNISUF_.doDeleteAfterInstall)                                           ,  {doDeleteAfterInstall    }
  ord(structDEFVER_UNISUF_.doUninsAlwaysUninstall)                                         ,  {doUninsAlwaysUninstall  }
  {$IF DEFVER>=5200}ord(structDEFVER_UNISUF_.doSetNTFSCompression)      {$ELSE}255{$IFEND} ,  {doSetNTFSCompression    }
  {$IF DEFVER>=5200}ord(structDEFVER_UNISUF_.doUnsetNTFSCompression)    {$ELSE}255{$IFEND}    {doUnsetNTFSCompression  }
);

  SetupIniOptionTable: array[0..MySetupIniOptionLast] of byte = (
  ord(structDEFVER_UNISUF_.ioCreateKeyIfDoesntExist)                       ,  {ioCreateKeyIfDoesntExist     }
  ord(structDEFVER_UNISUF_.ioUninsDeleteEntry)                             ,  {ioUninsDeleteEntry           }
  ord(structDEFVER_UNISUF_.ioUninsDeleteEntireSection)                     ,  {ioUninsDeleteEntireSection   }
  ord(structDEFVER_UNISUF_.ioUninsDeleteSectionIfEmpty)                    ,  {ioUninsDeleteSectionIfEmpty  }
  ord(structDEFVER_UNISUF_.ioHasValue)                                        {ioHasValue                   }
);

  SetupHeaderOptionTable: array[0..MySetupHeaderOptionLast] of byte = (
    ord(structDEFVER_UNISUF_.shDisableStartupPrompt),
    {$IF DEFVER<5310}ord(structDEFVER_UNISUF_.shUninstallable)             {$ELSE}255{$IFEND},
    ord(structDEFVER_UNISUF_.shCreateAppDir),
    ord(structDEFVER_UNISUF_.shAllowNoIcons),
    {$IF (DEFVER>=3003) AND (DEFVER < 3000)}ord(structDEFVER_UNISUF_.shAlwaysRestart) {$ELSE}255{$IFEND},
    ord(structDEFVER_UNISUF_.shAlwaysUsePersonalGroup),
    ord(structDEFVER_UNISUF_.shWindowVisible),
    ord(structDEFVER_UNISUF_.shWindowShowCaption),
    ord(structDEFVER_UNISUF_.shWindowResizable),
    ord(structDEFVER_UNISUF_.shWindowStartMaximized),
    ord(structDEFVER_UNISUF_.shEnableDirDoesntExistWarning),
    ord(structDEFVER_UNISUF_.shPassword),
    ord(structDEFVER_UNISUF_.shAllowRootDirectory),
    ord(structDEFVER_UNISUF_.shDisableFinishedPage),
    ord(structDEFVER_UNISUF_.shChangesAssociations),
    ord(structDEFVER_UNISUF_.shUsePreviousAppDir),
    ord(structDEFVER_UNISUF_.shBackColorHorizontal),
    ord(structDEFVER_UNISUF_.shUsePreviousGroup),
    ord(structDEFVER_UNISUF_.shUpdateUninstallLogAppName),
    ord(structDEFVER_UNISUF_.shUsePreviousSetupType),
    ord(structDEFVER_UNISUF_.shDisableReadyMemo),
    ord(structDEFVER_UNISUF_.shAlwaysShowComponentsList),
    ord(structDEFVER_UNISUF_.shFlatComponentsList),
    ord(structDEFVER_UNISUF_.shShowComponentSizes),
    ord(structDEFVER_UNISUF_.shUsePreviousTasks),
    ord(structDEFVER_UNISUF_.shDisableReadyPage),
    ord(structDEFVER_UNISUF_.shAlwaysShowDirOnReadyPage),
    ord(structDEFVER_UNISUF_.shAlwaysShowGroupOnReadyPage),
    {$IF DEFVER>=2018}ord(structDEFVER_UNISUF_.shAllowUNCPath)             {$ELSE}255{$IFEND},
    {$IF DEFVER>=3000}ord(structDEFVER_UNISUF_.shUserInfoPage)             {$ELSE}255{$IFEND},
    {$IF DEFVER>=3000}ord(structDEFVER_UNISUF_.shUsePreviousUserInfo)      {$ELSE}255{$IFEND},
    {$IF DEFVER>=3001}ord(structDEFVER_UNISUF_.shUninstallRestartComputer) {$ELSE}255{$IFEND},
    {$IF DEFVER>=3003}ord(structDEFVER_UNISUF_.shRestartIfNeededByRun)     {$ELSE}255{$IFEND},
    {$IF DEFVER>=3008}ord(structDEFVER_UNISUF_.shShowTasksTreeLines)       {$ELSE}255{$IFEND},
    {$IF DEFVER>=4009}ord(structDEFVER_UNISUF_.shAllowCancelDuringInstall) {$ELSE}255{$IFEND},
    {$IF DEFVER>=4103}ord(structDEFVER_UNISUF_.shWizardImageStretch)       {$ELSE}255{$IFEND},
    {$IF DEFVER>=4108}ord(structDEFVER_UNISUF_.shAppendDefaultDirName)     {$ELSE}255{$IFEND},
    {$IF DEFVER>=4108}ord(structDEFVER_UNISUF_.shAppendDefaultGroupName)   {$ELSE}255{$IFEND},
    {$IF DEFVER>=4202}ord(structDEFVER_UNISUF_.shEncryptionUsed)           {$ELSE}255{$IFEND},
    {$IF DEFVER>=5004}ord(structDEFVER_UNISUF_.shChangesEnvironment)       {$ELSE}255{$IFEND},
    {$IF (DEFVER>=5107) AND (NOT DEFINED(UNICODE))}
      ord(structDEFVER_UNISUF_.shShowUndisplayableLanguages)
    {$ELSE}255{$IFEND},
    {$IF DEFVER>=5113}ord(structDEFVER_UNISUF_.shSetupLogging)             {$ELSE}255{$IFEND},
    {$IF DEFVER>=5201}ord(structDEFVER_UNISUF_.shSignedUninstaller)        {$ELSE}255{$IFEND},
    {$IF DEFVER>=5308}ord(structDEFVER_UNISUF_.shUsePreviousLanguage)      {$ELSE}255{$IFEND},
    {$IF DEFVER>=5309}ord(structDEFVER_UNISUF_.shDisableWelcomePage)       {$ELSE}255{$IFEND},
    {$IF DEFVER>=5500}ord(structDEFVER_UNISUF_.shCloseApplications)       {$ELSE}255{$IFEND},
    {$IF DEFVER>=5500}ord(structDEFVER_UNISUF_.shRestartApplications)       {$ELSE}255{$IFEND},
    {$IF DEFVER>=5500}ord(structDEFVER_UNISUF_.shAllowNetworkDrive)       {$ELSE}255{$IFEND}
  );

  SetupRunOptionTable: array[0..MySetupRunOptionLast] of byte = (
    ord(structDEFVER_UNISUF_.roShellExec),
    ord(structDEFVER_UNISUF_.roSkipIfDoesntExist),
    ord(structDEFVER_UNISUF_.roPostInstall),
    ord(structDEFVER_UNISUF_.roUnchecked),
    ord(structDEFVER_UNISUF_.roSkipIfSilent),
    ord(structDEFVER_UNISUF_.roSkipIfNotSilent),
    ord(structDEFVER_UNISUF_.roHideWizard),
    {$IF DEFVER>=5110}ord(structDEFVER_UNISUF_.roRun32Bit)            {$ELSE}255{$IFEND},
    {$IF DEFVER>=5110}ord(structDEFVER_UNISUF_.roRun64Bit)            {$ELSE}255{$IFEND},
    {$IF DEFVER>=5200}ord(structDEFVER_UNISUF_.roRunAsOriginalUser)   {$ELSE}255{$IFEND}
  );

constructor TAnInnoVer.Create;
begin
  VerSupported:=DEFVER;
  IsUnicode:={$IFDEF UNICODE}true{$ELSE}false{$ENDIF};
  SetupID:=SetupLdrOffsetTableId;
  OfsTabSize:=sizeof(TSetupLdrOffsetTable);
end;

procedure TAnInnoVer.SetupSizes;
begin
  MyTypes.SetupLdrOffsetTableSize:=sizeof(TSetupLdrOffsetTable);

  MyTypes.SetupHeaderSize:=sizeof(TSetupHeader);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupHeaderStrings:=SetupHeaderStrings;
    MyTypes.SetupHeaderAnsiStrings:=SetupHeaderAnsiStrings;
    {$ELSE}
    MyTypes.SetupHeaderStrings:=0;
    MyTypes.SetupHeaderAnsiStrings:=SetupHeaderStrings+SetupHeaderAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupHeaderStrings:=0;
  MyTypes.SetupHeaderAnsiStrings:=SetupHeaderStrings;
  {$IFEND}

  {$IF DEFVER>=4000}
  MyTypes.SetupLanguageEntrySize:=sizeof(TSetupLanguageEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupLanguageEntryStrings:=SetupLanguageEntryStrings;
    MyTypes.SetupLanguageEntryAnsiStrings:=SetupLanguageEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupLanguageEntryStrings:=0;
    MyTypes.SetupLanguageEntryAnsiStrings:=SetupLanguageEntryStrings+SetupLanguageEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupLanguageEntryStrings:=0;
  MyTypes.SetupLanguageEntryAnsiStrings:=SetupLanguageEntryStrings;
  {$IFEND}
  {$ELSE}
  MyTypes.SetupLanguageEntrySize:=sizeof(TSetupLangOptions);
  MyTypes.SetupLanguageEntryStrings:=SetupLangOptionsStrings;
  {$IFEND}

  {$IF DEFVER>=4201}
  MyTypes.SetupCustomMessageEntrySize:=sizeof(TSetupCustomMessageEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupCustomMessageEntryStrings:=SetupCustomMessageEntryStrings;
    MyTypes.SetupCustomMessageEntryAnsiStrings:=SetupCustomMessageEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupCustomMessageEntryStrings:=0;
    MyTypes.SetupCustomMessageEntryAnsiStrings:=SetupCustomMessageEntryStrings+SetupCustomMessageEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupCustomMessageEntryStrings:=0;
  MyTypes.SetupCustomMessageEntryAnsiStrings:=SetupCustomMessageEntryStrings;
  {$IFEND}
  {$ELSE}
  MyTypes.SetupCustomMessageEntrySize:=0;
  MyTypes.SetupCustomMessageEntryStrings:=0;
  {$IFEND}

  {$IF DEFVER>=4100}
  MyTypes.SetupPermissionEntrySize:=sizeof(TSetupPermissionEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupPermissionEntryStrings:=SetupPermissionEntryStrings;
    MyTypes.SetupPermissionEntryAnsiStrings:=SetupPermissionEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupPermissionEntryStrings:=0;
    MyTypes.SetupPermissionEntryAnsiStrings:=SetupPermissionEntryStrings+SetupPermissionEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupPermissionEntryStrings:=0;
  MyTypes.SetupPermissionEntryAnsiStrings:=SetupPermissionEntryStrings;
  {$IFEND}
  {$ELSE}
  MyTypes.SetupPermissionEntrySize:=0;
  MyTypes.SetupPermissionEntryStrings:=0;
  {$IFEND}

  MyTypes.SetupTypeEntrySize:=sizeof(TSetupTypeEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupTypeEntryStrings:=SetupTypeEntryStrings;
    MyTypes.SetupTypeEntryAnsiStrings:=SetupTypeEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupTypeEntryStrings:=0;
    MyTypes.SetupTypeEntryAnsiStrings:=SetupTypeEntryStrings+SetupTypeEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupTypeEntryStrings:=0;
  MyTypes.SetupTypeEntryAnsiStrings:=SetupTypeEntryStrings;
  {$IFEND}

  MyTypes.SetupComponentEntrySize:=sizeof(TSetupComponentEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupComponentEntryStrings:=SetupComponentEntryStrings;
    MyTypes.SetupComponentEntryAnsiStrings:=SetupComponentEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupComponentEntryStrings:=0;
    MyTypes.SetupComponentEntryAnsiStrings:=SetupComponentEntryStrings+SetupComponentEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupComponentEntryStrings:=0;
  MyTypes.SetupComponentEntryAnsiStrings:=SetupComponentEntryStrings;
  {$IFEND}

  MyTypes.SetupTaskEntrySize:=sizeof(TSetupTaskEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupTaskEntryStrings:=SetupTaskEntryStrings;
    MyTypes.SetupTaskEntryAnsiStrings:=SetupTaskEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupTaskEntryStrings:=0;
    MyTypes.SetupTaskEntryAnsiStrings:=SetupTaskEntryStrings+SetupTaskEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupTaskEntryStrings:=0;
  MyTypes.SetupTaskEntryAnsiStrings:=SetupTaskEntryStrings;
  {$IFEND}

  MyTypes.SetupDirEntrySize:=sizeof(TSetupDirEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupDirEntryStrings:=SetupDirEntryStrings;
    MyTypes.SetupDirEntryAnsiStrings:=SetupDirEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupDirEntryStrings:=0;
    MyTypes.SetupDirEntryAnsiStrings:=SetupDirEntryStrings+SetupDirEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupDirEntryStrings:=0;
  MyTypes.SetupDirEntryAnsiStrings:=SetupDirEntryStrings;
  {$IFEND}

  MyTypes.SetupFileEntrySize:=sizeof(TSetupFileEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupFileEntryStrings:=SetupFileEntryStrings;
    MyTypes.SetupFileEntryAnsiStrings:=SetupFileEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupFileEntryStrings:=0;
    MyTypes.SetupFileEntryAnsiStrings:=SetupFileEntryStrings+SetupFileEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupFileEntryStrings:=0;
  MyTypes.SetupFileEntryAnsiStrings:=SetupFileEntryStrings;
  {$IFEND}

  MyTypes.SetupIconEntrySize:=sizeof(TSetupIconEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupIconEntryStrings:=SetupIconEntryStrings;
    MyTypes.SetupIconEntryAnsiStrings:=SetupIconEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupIconEntryStrings:=0;
    MyTypes.SetupIconEntryAnsiStrings:=SetupIconEntryStrings+SetupIconEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupIconEntryStrings:=0;
  MyTypes.SetupIconEntryAnsiStrings:=SetupIconEntryStrings;
  {$IFEND}

  MyTypes.SetupIniEntrySize:=sizeof(TSetupIniEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupIniEntryStrings:=SetupIniEntryStrings;
    MyTypes.SetupIniEntryAnsiStrings:=SetupIniEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupIniEntryStrings:=0;
    MyTypes.SetupIniEntryAnsiStrings:=SetupIniEntryStrings+SetupIniEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupIniEntryStrings:=0;
  MyTypes.SetupIniEntryAnsiStrings:=SetupIniEntryStrings;
  {$IFEND}

  MyTypes.SetupRegistryEntrySize:=sizeof(TSetupRegistryEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupRegistryEntryStrings:=SetupRegistryEntryStrings;
    MyTypes.SetupRegistryEntryAnsiStrings:=SetupRegistryEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupRegistryEntryStrings:=0;
    MyTypes.SetupRegistryEntryAnsiStrings:=SetupRegistryEntryStrings+SetupRegistryEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupRegistryEntryStrings:=0;
  MyTypes.SetupRegistryEntryAnsiStrings:=SetupRegistryEntryStrings;
  {$IFEND}

  MyTypes.SetupDeleteEntrySize:=sizeof(TSetupDeleteEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupDeleteEntryStrings:=SetupDeleteEntryStrings;
    MyTypes.SetupDeleteEntryAnsiStrings:=SetupDeleteEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupDeleteEntryStrings:=0;
    MyTypes.SetupDeleteEntryAnsiStrings:=SetupDeleteEntryStrings+SetupDeleteEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupDeleteEntryStrings:=0;
  MyTypes.SetupDeleteEntryAnsiStrings:=SetupDeleteEntryStrings;
  {$IFEND}

  MyTypes.SetupRunEntrySize:=sizeof(TSetupRunEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupRunEntryStrings:=SetupRunEntryStrings;
    MyTypes.SetupRunEntryAnsiStrings:=SetupRunEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupRunEntryStrings:=0;
    MyTypes.SetupRunEntryAnsiStrings:=SetupRunEntryStrings+SetupRunEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupRunEntryStrings:=0;
  MyTypes.SetupRunEntryAnsiStrings:=SetupRunEntryStrings;
  {$IFEND}

  MyTypes.SetupFileLocationEntrySize:=sizeof(TSetupFileLocationEntry);
  {$IF DEFVER>=UNI_FIRST}
    {$IFDEF UNICODE}
    MyTypes.SetupFileLocationEntryStrings:=SetupFileLocationEntryStrings;
    MyTypes.SetupFileLocationEntryAnsiStrings:=SetupFileLocationEntryAnsiStrings;
    {$ELSE}
    MyTypes.SetupFileLocationEntryStrings:=0;
    MyTypes.SetupFileLocationEntryAnsiStrings:=SetupFileLocationEntryStrings+SetupFileLocationEntryAnsiStrings;
    {$ENDIF}
  {$ELSE}
  MyTypes.SetupFileLocationEntryStrings:=0;
  MyTypes.SetupFileLocationEntryAnsiStrings:=SetupFileLocationEntryStrings;
  {$IFEND}
end;

// the following procedures extract information from important
// version-specific data structures. they are applied to whatever
// data is read from the installation file. all the other extraction
// code operates on the produced unified version-independent structures

procedure TAnInnoVer.UnifySetupLdrOffsetTable(const p; var ot:TMySetupLdrOffsetTable);
var
  oot:TSetupLdrOffsetTable absolute p;
begin
  with ot do begin
    ID                          :=oot.ID;
    TotalSize                   :=oot.TotalSize;
    OffsetEXE                   :=oot.OffsetEXE;
//    {$IF DEFVER<=4106} // since the main installer exe is not unpacked, there's no need for its size
//    CompressedSizeEXE           :=oot.CompressedSizeEXE;
//    {$IFEND}
    UncompressedSizeEXE         :=oot.UncompressedSizeEXE;
    {$IF DEFVER>=4003}
      CRCEXE                    :=oot.CRCEXE;
    {$ELSE}
      CRCEXE                    :=oot.AdlerEXE;
    {$IFEND}
    Offset0                     :=oot.Offset0;
    Offset1                     :=oot.Offset1;
    {$IF DEFVER>=4010}
      TableCRC                  :=oot.TableCRC;
      TableCRCUsed:=true;
    {$ELSE}
      TableCRCUsed:=false;
    {$IFEND}
  end;
end;

procedure TAnInnoVer.UnifySetupHeader(const p; var sh:TMySetupHeader);
var
  osh:TSetupHeader absolute p;
begin
  with sh do begin
    AppName                     :=osh.AppName;
    AppVerName                  :=osh.AppVerName;
    AppId                       :=osh.AppId;
    AppCopyright                :=osh.AppCopyright;
    AppPublisher                :=osh.AppPublisher;
    AppPublisherURL             :=osh.AppPublisherURL;
    AppSupportURL               :=osh.AppSupportURL;
    AppUpdatesURL               :=osh.AppUpdatesURL;
    AppVersion                  :=osh.AppVersion;
    DefaultDirName              :=osh.DefaultDirName;
    DefaultGroupName            :=osh.DefaultGroupName;
    BaseFilename                :=osh.BaseFilename;
    {$IF DEFVER>=4000}
    NumLanguageEntries          :=osh.NumLanguageEntries;
    CompiledCodeText            :=osh.CompiledCodeText;
    {$ELSE}
    NumLanguageEntries          :=0;
    CompiledCodeText            :='';
    {$IFEND}
    LicenseText                 :=osh.LicenseText;
    InfoBeforeText              :=osh.InfoBeforeText;
    InfoAfterText               :=osh.InfoAfterText;
    {$IF DEFVER>=4201}
    NumCustomMessageEntries     :=osh.NumCustomMessageEntries;
    {$ELSE}
    NumCustomMessageEntries     :=0;
    {$IFEND}
    {$IF DEFVER>=4100}
    NumPermissionEntries        :=osh.NumPermissionEntries;
    {$ELSE}
    NumPermissionEntries        :=0;
    {$IFEND}
    NumTypeEntries              :=osh.NumTypeEntries;
    NumComponentEntries         :=osh.NumComponentEntries;
    NumTaskEntries              :=osh.NumTaskEntries;
    NumDirEntries               :=osh.NumDirEntries;
    NumFileEntries              :=osh.NumFileEntries;
    NumFileLocationEntries      :=osh.NumFileLocationEntries;
    NumIconEntries              :=osh.NumIconEntries;
    NumIniEntries               :=osh.NumIniEntries;
    NumRegistryEntries          :=osh.NumRegistryEntries;
    NumInstallDeleteEntries     :=osh.NumInstallDeleteEntries;
    NumUninstallDeleteEntries   :=osh.NumUninstallDeleteEntries;
    NumRunEntries               :=osh.NumRunEntries;
    NumUninstallRunEntries      :=osh.NumUninstallRunEntries;
    MinVersion                  :=TMySetupVersionData(osh.MinVersion);
    OnlyBelowVersion            :=TMySetupVersionData(osh.OnlyBelowVersion);
    ExtraDiskSpaceRequired      :=Integer64(Int64(osh.ExtraDiskSpaceRequired));
    {$IF DEFVER>=4000}
    SlicesPerDisk               :=osh.SlicesPerDisk;
    {$ELSE}
    SlicesPerDisk               :=1;
    {$IFEND}
    {$IF DEFVER>=4105}
    case osh.CompressMethod of
      {$IF DEFVER>=4205}
      cmStored:                 CompressMethod:=MyTypes.cmStored;
      {$IFEND}
      {$IF DEFVER<>4205}
      cmZip:                    CompressMethod:=MyTypes.cmZip;
      {$IFEND}
      cmBzip:                   CompressMethod:=MyTypes.cmBzip;
      cmLZMA:                   CompressMethod:=MyTypes.cmLZMA;
	    {$IF DEFVER>=5309}
	    cmLZMA2:                  CompressMethod:=MyTypes.cmLZMA2;
	    {$IFEND}
    end;
    {$ELSEIF DEFVER >= 2017}
    if shBzipUsed in osh.Options then CompressMethod:=MyTypes.cmBzip
    else CompressMethod:=MyTypes.cmZip;
    {$ELSE}
    CompressMethod:=MyTypes.cmZip;
    {$IFEND}
    {$IF DEFVER>=4202}
    EncryptionUsed:=shEncryptionUsed in osh.Options;
    {$IF DEFVER>=5309}
    Move(osh.PasswordHash, PasswordHash_SHA1, sizeof(PasswordHash_SHA1));
	  {$ELSE}
	  Move(osh.PasswordHash, PasswordHash_MD5, sizeof(PasswordHash_MD5));
	  {$IFEND}
    Move(osh.PasswordSalt, PasswordSalt, sizeof(PasswordSalt));
    {$ELSE}
    EncryptionUsed:=false;
    {$IFEND}
    {$IF DEFVER>=5100}
    Move(osh.ArchitecturesAllowed, ArchitecturesAllowed, sizeof(ArchitecturesAllowed));
    Move(osh.ArchitecturesInstallIn64BitMode, ArchitecturesInstallIn64BitMode, sizeof(ArchitecturesInstallIn64BitMode));
    {$ELSE}
    ArchitecturesAllowed:=[];
    ArchitecturesInstallIn64BitMode:=[];
    {$IFEND}
    {$IF DEFVER>=3004}
    case osh.PrivilegesRequired of
      prNone:       PrivilegesRequired := MyTypes.prNone;
      prPowerUser:  PrivilegesRequired := MyTypes.prPowerUser;
      prAdmin:      PrivilegesRequired := MyTypes.prAdmin;
      {$IF DEFVER>=5307}
      prLowest:     PrivilegesRequired := MyTypes.prLowest;
      {$IFEND}
    end;
    {$ELSE}
    if (shAdminPrivilegesRequired in osh.Options) then
      PrivilegesRequired := MyTypes.prAdmin
    else
      PrivilegesRequired := MyTypes.prNone;
    {$IFEND}
    UninstallFilesDir     := osh.UninstallFilesDir;
    UninstallDisplayName  := osh.UninstallDisplayName;
    UninstallDisplayIcon  := osh.UninstallDisplayIcon;
    AppMutex              := osh.AppMutex;
    {$IF DEFVER>=4204}
    AppReadmeFile         := osh.AppReadmeFile;
    AppContact            := osh.AppContact;
    AppComments           := osh.AppComments;
    AppModifyPath         := osh.AppModifyPath;
    {$ELSE}
    AppReadmeFile         := '';
    AppContact            := '';
    AppComments           := '';
    AppModifyPath         := '';
    {$IFEND}
    {$IF DEFVER>=5308}
    CreateUninstallRegKey := osh.CreateUninstallRegKey;
    {$ELSE}
    if (shCreateUninstallRegKey in osh.Options) then
      CreateUninstallRegKey := 'yes'
    else
      CreateUninstallRegKey := 'no';
    {$IFEND}
    {$IF DEFVER>=5310}
    Uninstallable := osh.Uninstallable;
    {$ELSE}
    Uninstallable := '';
    {$IFEND}
    {$IF DEFVER>=5303}
    case osh.DisableDirPage of
      dpAuto: DisableDirPage := MyTypes.dpAuto;
      dpNo:   DisableDirPage := MyTypes.dpNo;
      dpYes:  DisableDirPage := MyTypes.dpYes;
    end;
    case osh.DisableProgramGroupPage of
      dpAuto: DisableProgramGroupPage := MyTypes.dpAuto;
      dpNo:   DisableProgramGroupPage := MyTypes.dpNo;
      dpYes:  DisableProgramGroupPage := MyTypes.dpYes;
    end;
    {$ELSE}
    if (shDisableDirPage in osh.Options) then
      DisableDirPage := MyTypes.dpYes
    else
      DisableDirPage := MyTypes.dpNo;
    if (shDisableProgramGroupPage in osh.Options) then
      DisableProgramGroupPage := MyTypes.dpYes
    else
      DisableProgramGroupPage := MyTypes.dpNo;
    {$IFEND}
  end;
  TranslateSet(osh.Options, sh.Options, PByteArray(@SetupHeaderOptionTable)^, MySetupHeaderOptionLast);
end;

procedure TAnInnoVer.UnifyFileEntry(const p; var fe:TMySetupFileEntry);
var
  ofe: TSetupFileEntry absolute p;
begin
  with fe do begin
    SourceFilename              := ofe.SourceFilename;
    DestName                    := ofe.DestName;
    Components                  := ofe.Components;
    Tasks                       := ofe.Tasks;
    {$IF DEFVER>=4000}
    Check                       := ofe.Check;
    {$ELSE}
    Check                       := '';
    {$IFEND}
    {$IF DEFVER>=4001}
    Languages                   := ofe.Languages;
    {$ELSE}
    Languages                   := '';
    {$IFEND}
    {$IF DEFVER>=4100}
    AfterInstall                := ofe.AfterInstall;
    BeforeInstall               := ofe.BeforeInstall;
    PermissionsEntry            := ofe.PermissionsEntry;
    {$ELSE}
    AfterInstall                := '';
    BeforeInstall               := '';
    PermissionsEntry            := 0;
    {$IFEND}
    MinVersion                  := TMySetupVersionData(ofe.MinVersion);
    OnlyBelowVersion            := TMySetupVersionData(ofe.OnlyBelowVersion);
    LocationEntry               := ofe.LocationEntry;
    ExternalSize                := Integer64(Int64(ofe.ExternalSize));
    Attribs                     := ofe.Attribs;
    case ofe.FileType of
      ftUserFile: FileType  := MyTypes.ftUserFile;
      ftUninstExe: FileType := MyTypes.ftUninstExe;
      {$IF DEFVER<5000}
      ftRegSvrExe: FileType := MyTypes.ftRegSvrExe;
      {$IFEND}
    end;
  end;
  TranslateSet(ofe.Options, fe.Options, PByteArray(@SetupFileOptionTable)^, MySetupFileOptionLast);
end;

procedure TAnInnoVer.UnifyFileLocationEntry(const p; var fl:TMySetupFileLocationEntry);
var
  ofl: TSetupFileLocationEntry absolute p;
begin
  with fl do begin
    {$IF DEFVER>=4000}
    FirstSlice                  :=ofl.FirstSlice;
    LastSlice                   :=ofl.LastSlice;
    {$ELSE}
    FirstSlice                  :=ofl.FirstDisk;
    LastSlice                   :=ofl.LastDisk;
    {$IFEND}
    StartOffset                 :=ofl.StartOffset;
    {$IF DEFVER<=4000}
    ChunkSuboffset.Hi:=0; ChunkSuboffset.Lo:=0;
    ChunkCompressedSize         :=Integer64(Int64(ofl.CompressedSize));
    {$ELSE}
    ChunkSuboffset              :=ofl.ChunkSuboffset;
    ChunkCompressedSize         :=ofl.ChunkCompressedSize;
    {$IFEND}
    OriginalSize                :=Integer64(Int64(ofl.OriginalSize));    

    {$IF DEFVER>=5309}
    SHA1Sum                     := ofl.SHA1Sum;
    HashType                    := htSHA1;
    {$ELSEIF DEFVER>=4200}
    MD5Sum                      := ofl.MD5Sum;
    HashType                    := htMD5;
    {$ELSEIF DEFVER>=4001}
    CRC                         := ofl.CRC;
    HashType                    := htCRC32;
    {$ELSE}
    CRC                         := ofl.Adler;
    HashType                    := htAdler;
    {$IFEND}

    {$IF DEFVER<4010}
    TimeStamp                   :=ofl.Date;
    {$ELSE}
    TimeStamp                   :=ofl.TimeStamp;
    {$IFEND}
    FileVersionMS               :=ofl.FileVersionMS;
    FileVersionLS               :=ofl.FileVersionLS;
//    if structDEFVER_UNISUF_.foIsUninstExe in ofl.Flags then Flags:=[MyTypes.foIsUninstExe] else Flags:=[];
    {$IF DEFVER>=4108}
    if structDEFVER_UNISUF_.foCallInstructionOptimized in ofl.Flags then Include(Flags, MyTypes.foCallInstructionOptimized);
    {$IFEND}
    {$IF DEFVER>=4202}
    if structDEFVER_UNISUF_.foChunkEncrypted in ofl.Flags then Include(Flags, MyTypes.foChunkEncrypted);
    {$IFEND}
    {$IF DEFVER>=4205}
    if structDEFVER_UNISUF_.foChunkCompressed in ofl.Flags then Include(Flags, MyTypes.foChunkCompressed);
    {$ELSE}
    Include(Flags, MyTypes.foChunkCompressed);
    {$IFEND}
    {$IF DEFVER>=4010}
    if structDEFVER_UNISUF_.foTimeStampInUTC in ofl.Flags then Include(Flags, MyTypes.foTimeStampInUTC);
    {$IFEND}
    Contents:='';
    PrimaryFileEntry:=-1;
  end;
end;

procedure TAnInnoVer.UnifyRegistryEntry(const p; var re:TMySetupRegistryEntry);
var
  ore: TSetupRegistryEntry absolute p;
begin
  with re do begin
    RootKey                       :=ore.RootKey;
    Subkey                        :=ore.Subkey;
    ValueName                     :=ore.ValueName;
    ValueData                     :=ore.ValueData;

    Components                    :=ore.Components;
    Tasks                         :=ore.Tasks;
    {$IF DEFVER>=4000}
    Check                         :=ore.Check;
    {$ELSE}
    Check                         :='';
    {$IFEND}
    {$IF DEFVER>=4001}
    Languages                     :=ore.Languages;
    {$ELSE}
    Languages                     :='';
    {$IFEND}
    {$IF DEFVER>=4100}
    AfterInstall                  :=ore.AfterInstall;
    BeforeInstall                 :=ore.BeforeInstall;
    {$ELSE}
    AfterInstall                  :='';
    BeforeInstall                 :='';
    {$IFEND}
    MinVersion                    :=TMySetupVersionData(ore.MinVersion);
    OnlyBelowVersion              :=TMySetupVersionData(ore.OnlyBelowVersion);

    case ore.Typ of
      rtNone         : Typ:=MyTypes.rtNone;
      rtString       : Typ:=MyTypes.rtString;
      rtExpandString : Typ:=MyTypes.rtExpandString;
      rtDWord        : Typ:=MyTypes.rtDWord;
      rtBinary       : Typ:=MyTypes.rtBinary;
      rtMultiString  : Typ:=MyTypes.rtMultiString;
      {$IF DEFVER>=5205}
      rtQWord        : Typ:=MyTypes.rtQWord;
      {$IFEND}
    end;
  end;
  TranslateSet(ore.Options, re.Options, PByteArray(@SetupRegistryOptionTable)^, MySetupRegistryOptionLast);
end;

procedure TAnInnoVer.UnifyRunEntry(const p; var re:TMySetupRunEntry);
var
  ore: TSetupRunEntry absolute p;
begin
  with re do begin
    Name                          :=ore.Name;
    Parameters                    :=ore.Parameters;
    WorkingDir                    :=ore.WorkingDir;
    RunOnceId                     :=ore.RunOnceId;
    StatusMsg                     :=ore.StatusMsg;
    {$IF DEFVER>=5113}
    Verb                          :=ore.Verb;
    {$ELSE}
    Verb                          :='';
    {$IFEND}
    Description                   :=ore.Description;
    Components                    :=ore.Components;
    Tasks                         :=ore.Tasks;
    {$IF DEFVER>=4000}
    Check                         :=ore.Check;
    {$ELSE}
    Check                         :='';
    {$IFEND}
    {$IF DEFVER>=4001}
    Languages                     :=ore.Languages;
    {$ELSE}
    Languages                     :='';
    {$IFEND}
    {$IF DEFVER>=4100}
    AfterInstall                  :=ore.AfterInstall;
    BeforeInstall                 :=ore.BeforeInstall;
    {$ELSE}
    AfterInstall                  :='';
    BeforeInstall                 :='';
    {$IFEND}
    MinVersion                    :=TMySetupVersionData(ore.MinVersion);
    OnlyBelowVersion              :=TMySetupVersionData(ore.OnlyBelowVersion);

    case ore.Wait of
      rwWaitUntilTerminated : Wait := MyTypes.rwWaitUntilTerminated;
      rwNoWait              : Wait := MyTypes.rwNoWait;
      rwWaitUntilIdle       : Wait := MyTypes.rwWaitUntilIdle;
    end;
  end;
  TranslateSet(ore.Options, re.Options, PByteArray(@SetupRunOptionTable)^, MySetupRunOptionLast);
end;

procedure TAnInnoVer.UnifyIconEntry(const p; var ie:TMySetupIconEntry);
var
  oie: TSetupIconEntry absolute p;
begin
  with ie do begin
    IconName                      :=oie.IconName;
    Filename                      :=oie.Filename;
    Parameters                    :=oie.Parameters;
    WorkingDir                    :=oie.WorkingDir;
    IconFilename                  :=oie.IconFilename;
    Comment                       :=oie.Comment;
    IconIndex                     :=oie.IconIndex;
    ShowCmd                       :=oie.ShowCmd;
    HotKey                        :=oie.HotKey;
    CloseOnExit                   :=TMySetupIconCloseOnExit(ord(oie.CloseOnExit));

    Components                    :=oie.Components;
    Tasks                         :=oie.Tasks;
    {$IF DEFVER>=4000}
    Check                         :=oie.Check;
    {$ELSE}
    Check                         :='';
    {$IFEND}
    {$IF DEFVER>=4001}
    Languages                     :=oie.Languages;
    {$ELSE}
    Languages                     :='';
    {$IFEND}
    {$IF DEFVER>=4100}
    AfterInstall                  :=oie.AfterInstall;
    BeforeInstall                 :=oie.BeforeInstall;
    {$ELSE}
    AfterInstall                  :='';
    BeforeInstall                 :='';
    {$IFEND}
    MinVersion                    :=TMySetupVersionData(oie.MinVersion);
    OnlyBelowVersion              :=TMySetupVersionData(oie.OnlyBelowVersion);
  end;
end;

procedure TAnInnoVer.UnifyTaskEntry(const p; var te:TMySetupTaskEntry);
var
  ote: TSetupTaskEntry absolute p;
begin
  with te do begin
    Name                          :=ote.Name;
    Description                   :=ote.Description;
    GroupDescription              :=ote.GroupDescription;
    Components                    :=ote.Components;
    {$IF DEFVER>=4001}
    Languages                     :=ote.Languages;
    {$ELSE}
    Languages                     :='';
    {$IFEND}
    {$IF DEFVER>=4000}
    Check                         :=ote.Check;
    {$ELSE}
    Check                         :='';
    {$IFEND}
    MinVersion                    :=TMySetupVersionData(ote.MinVersion);
    OnlyBelowVersion              :=TMySetupVersionData(ote.OnlyBelowVersion);
    Move(ote.Options,Options,sizeof(ote.Options));
  end;
end;

procedure TAnInnoVer.UnifyComponentEntry(const p; var ce:TMySetupComponentEntry);
var
  oce: TSetupComponentEntry absolute p;
begin
  with ce do begin
    Name                          :=oce.Name;
    Description                   :=oce.Description;
    Types                         :=oce.Types;
    ExtraDiskSpaceRequired        :=Integer64(Int64(oce.ExtraDiskSpaceRequired));
    {$IF DEFVER>=4001}
    Languages                     :=oce.Languages;
    {$ELSE}
    Languages                     :='';
    {$IFEND}
    {$IF DEFVER>=4000}
    Check                         :=oce.Check;
    {$ELSE}
    Check                         :='';
    {$IFEND}
    MinVersion                    :=TMySetupVersionData(oce.MinVersion);
    OnlyBelowVersion              :=TMySetupVersionData(oce.OnlyBelowVersion);
    Move(oce.Options,Options,sizeof(oce.Options));
  end;
end;

procedure TAnInnoVer.UnifyTypeEntry(const p; var te:TMySetupTypeEntry);
var
  ote: TSetupTypeEntry absolute p;
begin
  with te do begin
    Name                          :=ote.Name;
    Description                   :=ote.Description;
    {$IF DEFVER>=4001}
    Languages                     :=ote.Languages;
    {$ELSE}
    Languages                     :='';
    {$IFEND}
    {$IF DEFVER>=4000}
    Check                         :=ote.Check;
    {$ELSE}
    Check                         :='';
    {$IFEND}
    MinVersion                    :=TMySetupVersionData(ote.MinVersion);
    OnlyBelowVersion              :=TMySetupVersionData(ote.OnlyBelowVersion);
    Move(ote.Options,Options,sizeof(ote.Options));
    {$IF DEFVER>=4003}
    Typ                           :=TMySetupTypeType(ote.Typ);
    {$ELSE}
    Typ                           :=Low(TMySetupTypeType);
    {$IFEND}
  end;
end;

procedure TAnInnoVer.UnifyCustomMessageEntry(const p; var ce:TMySetupCustomMessageEntry);
{$IF DEFVER>=4201}
var
  oce: TSetupCustomMessageEntry absolute p;
begin
  with ce do begin
    Name                          :=NormalizeStringVal(oce.Name);
    Value                         :=NormalizeStringVal(oce.Value);
    LangIndex                     :=oce.LangIndex;
  end;
{$ELSE}
begin
{$IFEND}
end;

procedure TAnInnoVer.UnifyLanguageEntry(const p; var le:TMySetupLanguageEntry);
{$IF DEFVER>=4000}
var
  ole: TSetupLanguageEntry absolute p;
begin
  with le do begin
    Name                          :=ole.Name;
    LanguageName                  :=CopyStringVal(ole.LanguageName);
    DialogFontName                :=ole.DialogFontName;
    TitleFontName                 :=ole.TitleFontName;
    WelcomeFontName               :=ole.WelcomeFontName;
    CopyrightFontName             :=ole.CopyrightFontName;
    Data                          :=ole.Data;
{$IF DEFVER>=4001}
    LicenseText                   :=ole.LicenseText;
    InfoBeforeText                :=ole.InfoBeforeText;
    InfoAfterText                 :=ole.InfoAfterText;
{$ELSE}
    LicenseText                   :='';
    InfoBeforeText                :='';
    InfoAfterText                 :='';
{$IFEND}
{$IF (DEFVER>=4202) AND not Defined(UNICODE)}
    LanguageCodePage              :=ole.LanguageCodePage;
{$ELSE}
    LanguageCodePage              :=0;
{$IFEND}
    LanguageID                    :=ole.LanguageID;
    DialogFontSize                :=ole.DialogFontSize;
    TitleFontSize                 :=ole.TitleFontSize;
    WelcomeFontSize               :=ole.WelcomeFontSize;
    CopyrightFontSize             :=ole.CopyrightFontSize;
    RightToLeft                   :={$IF DEFVER>=5203} ole.RightToLeft {$ELSE} false {$IFEND};
  end;
{$ELSE}
begin
{$IFEND}
end;

procedure TAnInnoVer.UnifyDirEntry(const p; var de: TMySetupDirEntry);
var
  ode: TSetupDirEntry absolute p;
begin
  with de do begin
    DirName             := ode.DirName;
    Components          := ode.Components;
    Tasks               := ode.Tasks;
    Languages           := {$IF DEFVER>=4001} ode.Languages {$ELSE} '' {$IFEND};
    Check               := {$IF DEFVER>=3008} ode.Check {$ELSE} '' {$IFEND};
{$IF DEFVER>=4100}
    AfterInstall        := ode.AfterInstall;
    BeforeInstall       := ode.BeforeInstall;
{$ELSE}
    AfterInstall        := '';
    BeforeInstall       := '';
{$IFEND}
    Attribs             := {$IF DEFVER>=2011} ode.Attribs {$ELSE} 0 {$IFEND}; 
    MinVersion          := TMySetupVersionData(ode.MinVersion);
    OnlyBelowVersion    := TMySetupVersionData(ode.OnlyBelowVersion);
  end;
  TranslateSet(ode.Options, de.Options, PByteArray(@SetupDirOptionTable)^, MySetupDirOptionLast);
end;

procedure TAnInnoVer.UnifyIniEntry(const p; var ie: TMySetupIniEntry);
var
  oie: TSetupIniEntry absolute p;
begin
  with ie do begin
    Filename            := oie.Filename;
    Section             := oie.Section;
    Entry               := oie.Entry;
    Value               := oie.Value;
    Components          := oie.Components;
    Tasks               := oie.Tasks;
    Languages           := {$IF DEFVER>=4001} oie.Languages {$ELSE} '' {$IFEND};
    Check               := {$IF DEFVER>=3008} oie.Check {$ELSE} '' {$IFEND};
{$IF DEFVER>=4100}
    AfterInstall        := oie.AfterInstall;
    BeforeInstall       := oie.BeforeInstall;
{$ELSE}
    AfterInstall        := '';
    BeforeInstall       := '';
{$IFEND}
    MinVersion          := TMySetupVersionData(oie.MinVersion);
    OnlyBelowVersion    := TMySetupVersionData(oie.OnlyBelowVersion);
  end;
  TranslateSet(oie.Options, ie.Options, PByteArray(@SetupIniOptionTable)^, MySetupIniOptionLast);
end;

procedure TAnInnoVer.UnifyDeleteEntry(const p; var de: TMySetupDeleteEntry);
var
  ode: TSetupDeleteEntry absolute p;
begin
  with de do begin
    Name                := ode.Name;
    Components          := ode.Components;
    Tasks               := ode.Tasks;
{$IF DEFVER>=4001}
    Languages           := ode.Languages;
{$ELSE}
    Languages           := '';
{$IFEND}
{$IF DEFVER>=3008}
    Check               := ode.Check;
{$ELSE}
    Check               := '';
{$IFEND}
{$IF DEFVER>=4100}
    AfterInstall        := ode.AfterInstall;
    BeforeInstall       := ode.BeforeInstall;
{$ELSE}
    AfterInstall        := '';
    BeforeInstall       := '';
{$IFEND}
    MinVersion          := TMySetupVersionData(ode.MinVersion);
    OnlyBelowVersion    := TMySetupVersionData(ode.OnlyBelowVersion);

    case ode.DeleteType of
      dfFiles:              DeleteType := MyTypes.dfFiles;
      dfFilesAndOrSubdirs:  DeleteType := MyTypes.dfFilesAndOrSubdirs;
      dfDirIfEmpty:         DeleteType := MyTypes.dfDirIfEmpty;
    end;
  end;  
end;

begin
  SetLength(VerList, Length(VerList)+1);
  VerList[High(VerList)] := TAnInnoVer.Create;
end.